package com.logicbig.example;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabase;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseBuilder;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseType;

import java.util.List;

public class JdbcTemplateTest {

    private JdbcTemplatePersonDao jdbcTemplatePersonDao;

    @Before
    public void setup() {
        EmbeddedDatabase db = new EmbeddedDatabaseBuilder()
                .setType(EmbeddedDatabaseType.H2)
                .addScript("createPersonTable.sql")
                .build();
        jdbcTemplatePersonDao = new JdbcTemplatePersonDao();
        jdbcTemplatePersonDao.setDataSource(db);
        jdbcTemplatePersonDao.postConstruct();
    }

    @Test
    public void testJdbcTempalte() {
        Person person = Person.create("Robin", "Cash", "64 Zella Park");
        jdbcTemplatePersonDao.save(person);

        List<Person> loadedPersons = jdbcTemplatePersonDao.loadAll();
        System.out.println("Loaded Persons: " + loadedPersons);
        for (Person loadedPerson : loadedPersons) {
            Assert.assertTrue("Robin".equals(loadedPerson.getFirstName()));
            Assert.assertTrue("Cash".equals(loadedPerson.getLastName()));
            Assert.assertTrue("64 Zella Park".equals(loadedPerson.getAddress()));
        }
    }
}